;--------------------------------;
;   Gigatron + UART_8250A.ASM    ;
;          12.09.2020            ;
;                                ;
; 0FFH -  ...   ;
;--------------------------------;

;0123456789012345
;> The Gigatron <
;Press any key...

    ORG  0000H;
START:
;-------------
    DB    0EH, 0FFH; NOP - Delay
    DB    0EH, 0FFH; NOP - 20 mS
    DB    10H, 55H;  LD  $55,X
    DB    14H, 88H;  LD  $88,Y
;-------------
    DB    0FH, 0FDH; LDA  IN,0FDH ;      
    DB    08H, 80H;    7 (  8250     )
    DB    1AH, 0FBH; LD  AC,OUT_0FBH; .1011    
    DB    1AH, 0FBH; LD  AC,OUT_0FBH; .1011    
;-------------
    DB    0FH, 0F9H;  LDA  IN,0F9H
    DB    08H, 00H;  ; 
    DB    1AH, 0F9H; LD  AC,OUT_0F9H; .1001     ()
    DB    1AH, 0F9H; LD  AC,OUT_0F9H; .1001     ()
;-------------
    DB    0FH, 0F8H;  LDA  IN,0F8H
    DB    08H, 0CH;  ; : 60h 1200, 0Ch 9600
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000     ()
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000     ()
;-------------
    DB    0FH, 0FBH;  LDA  IN,0FBH
    DB    08H, 000000011b; 8 
    DB    1AH, 0FBH; LD  AC,OUT_0FBH; .1011    
    DB    1AH, 0FBH; LD  AC,OUT_0FBH; .1011    
;-------------
    DB    0FH, 0F9H;  LDA  IN,0F9H
    DB    08H, 000000000b;  
    DB    1AH, 0F9H; LD  AC,OUT_0F9H; .1001
    DB    1AH, 0F9H; LD  AC,OUT_0F9H; .1001
;-------------
    DB    0FH, 0FCH;  LDA  IN,0FDH
    DB    08H, 000000011b       ; 
;    DB    1AH, 0F9H; LD  AC,OUT_0F9H; .1001
;-------------
    DB    1AH, 0FCH; LD  AC,OUT_0FCH; .1100   
    DB    1AH, 0FCH; LD  AC,OUT_0FCH; .1100   
;    DB    1AH, 0FEH; LD  AC,OUT_0FEH; .1110
;-------------
SEND:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEND/2)AND 0FFH;  BEQ SEND;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, '>';  LDA 41H
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN2:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN2/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, ' ';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN3:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN3/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'T';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN4:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN4/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'h';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 

;-------------
SEN5:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN5/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'e';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN6:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN6/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, ' ';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN7:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN7/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'G';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN8:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN8/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'I';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEN9:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEN9/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'G';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SENA:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SENA/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'A';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SENB:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SENB/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'T';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SENC:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SENC/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'R';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SEHD:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SEHD/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'O';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SENE:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SENE/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'N';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SENF:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SENF/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, ' ';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE10:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE10/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, '<';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE11:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE11/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 0DH;<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE12:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE12/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'P';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SET2:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SET2/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'r';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE13:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE13/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'e';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE14:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE14/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 's';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE15:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE15/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 's';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE16:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE16/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, ' ';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE17:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE17/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'a';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE18:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE18/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'n';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE19:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE19/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'y';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE1A:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE1A/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, ' ';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE1B:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE1B/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'k';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
    DB    0EH, 0FFH; NOP after JMP
    DB    0EH, 0FFH; NOP after JMP
    DB    0EH, 0FFH; NOP after JMP
    DB    0EH, 0FFH; NOP after JMP     
;-------------
SE1C:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE1C/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'e';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE1D:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE1D/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 'y';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE1E:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE1E/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, '.';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE1F:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE1F/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, '.';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE20:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE20/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, '.';<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
;-------------
SE21:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  02H = 00000010

    DB    0F0H,(SE21/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    08H, 0DH;<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP

;-------------
INP:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 00000001b ;   

    DB    0F0H,(INP/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0EH, 0A2H;  NOP
OUTP:
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 20H;   ANI  20H = 00000010

    DB    0F0H,(OUTP/2)AND 0FFH;  BEQ OUTP;
    DB    0EH, 0FDH; NOP after JMP
    DB    08H, 00H;<-LDA
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    0EH, 0F8H; NOP
    DB    1AH, 0F8H; LD  AC,OUT_0F8H; .1000   ; 
FIN:
    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    0FH, 0F8H; LDA  IN,0F8H
    DB    0FH, 0FDH;  LDA  IN,0FDH
    DB    0FH, 0FDH;  LDA  IN,0FDH .1101     
    DB    2CH, 00000001b ;   

    DB    0ECH,(FIN/2)AND 0FFH;  BEQ INP;
    DB    0EH, 0A2H; NOP after JMP

    DB    0FCH, (INP/2)AND 0FFH;  BRA INP
    DB    0EH, 0FDH; NOP after JMP

;-------------
TYTA:
    DB    0FCH, (TYTA/2)AND 0FFH;  BRA SEND
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP
    DB    0EH, 0EH; NOP after JMP

    DB    0A0H,0FFH; SUB 0FFH
    DB    0EH, 0FFH; NOP
    DB    0F0H,0F3H; BEQ INP; =0F0 =/=0ECH
    DB    0EH, 0FFH; NOP after JMP
    DB    14H, 00H;  LD  00H,Y
    DB    0E0H,53H;  JMP  Y,CLS
    DB    0EH, 0A2H; NOP after JMP



;-------------
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;

    END
;---------------------------------------